package	jp.co.sds_corp.syslog.layout;

import jp.co.sds_corp.util.syslog.SyslogMsg;

/**
* 固定文字列を出力します。
*/
public class LiteralLayout
{
	String		fmt;

	/**
	* 指定された文字列でLiteralLayoutを作成します。
	* @param	fmt		フォーマット文字列
	*/
	public LiteralLayout( String fmt ) {
		setFormat( fmt );
	}

	/**
	* フォーマット文字列を指定します。
	* @param	fmt		フォーマット文字列
	*/
	public void setFormat( String fmt ) {
		this.fmt = fmt;
	}

	/**
	* 文字列を出力します。
	* @param	msg		編集元のデータ
	* @return	編集結果の文字列
	*/
	public String format( SyslogMsg msg ) {
		return fmt;
	}

	/**
	* このレイアウトの文字列表現を返します。
	* @return	このレイアウトの文字列表現を返します。
	*/
	public String toString() {
		String ret = getClass().getName() + " format=[" + fmt + "]";
		return ret;
	}

}
