package	jp.co.sds_corp.syslog.viewer;

import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.text.DecimalFormat;
import java.util.ResourceBundle;

import javax.swing.JDialog;
import javax.swing.JEditorPane;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.text.html.HTMLDocument;
import javax.swing.text.html.HTMLFrameHyperlinkEvent;

import jp.co.sds_corp.util.common.CmnManifest;
import jp.co.sds_corp.util.window.WindowUtility;

/**
* SyslogViewerのバージョン情報を表示します。
*/
public class AboutDialog extends JDialog
{
	private static final long serialVersionUID = 1L;
	String title;
	String version;
	DecimalFormat df = new DecimalFormat( "#,###" );
	JDialog	dialog;
	JLabel	lbl;
	JOptionPane pane;
	ResourceBundle res;

	/**
	* versionを表示するダイアログを生成します。
	*/
	protected AboutDialog( Frame parent ) {
		super( parent, true );
		// createControl();
	}

	/**
	* versionを表示するダイアログを生成します。
	*/
	protected AboutDialog( Dialog parent ) {
		super( parent, true );
		// createControl();
	}

	/**
	* versionを表示するダイアログを生成します。
	*/
	protected AboutDialog() {
		super();
		// createControl();
	}

	private void createControl() {
		setModal( true );
		WindowUtility.setHideOnEscape( this );

		res = ResourceBundle.getBundle( "resource.viewer" );
		String text;
		text = res.getString( "about.title" );
		setTitle( text );

		WindowUtility.setHideOnEscape( this );

		lbl = createLabel();
		pane = new JOptionPane( lbl,
			JOptionPane.INFORMATION_MESSAGE, JOptionPane.DEFAULT_OPTION );
		setContentPane( pane );

		//dialog = pane.createDialog( parent, text );
		//getContentPane().add( lbl );

		lbl.setSize( new Dimension( 350, 200 ));
		pack();

/*
		JavaStatusText stat = new JavaStatusText();
		getContentPane().add( stat );
*/
	}

	public void setFont( Font f ) {
		lbl.setFont( f );
		super.setFont( f );
	}

	public void setVisible( boolean var ) {
		if ( var ) {
			createControl();
			pane.setValue( Integer.valueOf( -1 ));
			String text;
			text = res.getString( "about.title" );
			JDialog dlg = pane.createDialog( getParent(), text );
			dlg.setVisible( true );
			//showLabel();
			//showEditorPane();
			// super.setVisible( true );
			//dialog.setVisible( true );
		} else {
			super.setVisible( false );
		}
	}

	JLabel createLabel() {
		try {
			CmnManifest mn = new CmnManifest( getClass());
			title = mn.getTitle();
			version = mn.getVersion();
		} catch ( Exception e ) {
			e.printStackTrace();
		}
		Runtime	rt = Runtime.getRuntime();
		String html =
			"<HTML>"
			+ title + " ver " + version + "<BR>"
			+ "<BR>"
			+ "Copyright (C) 1995-2009 S.D.S. all rights reserved.<BR>"
			+ "<A HREF='http://www.sds-corp.co.jp/'>http://www.sds-corp.co.jp/</A><BR>"
			+ "<HR color='gray'><BR>"
			+ "maxMemory=" + df.format( rt.maxMemory() ) + "<BR>"
			+ "totalMemory=" + df.format( rt.totalMemory() ) + "<BR>"
			+ "freeMemory=" + df.format( rt.freeMemory() ) + "<BR>"
			+ "</HTML>";
		JLabel lbl = new JLabel( html );
		return lbl;
	}

	void showLabel() {
		String text;
		text = res.getString( "about.title" );
		JLabel lbl = createLabel();
		JOptionPane.showMessageDialog( this,
			lbl, text,
			JOptionPane.INFORMATION_MESSAGE );
	}

	void showEditorPane() {
		Runtime	rt = Runtime.getRuntime();
		String html =
			"<HTML>"
			+ title + " ver " + version + "<BR>"
			+ "<BR>"
			+ "Copyright (C) 1995-2009 S.D.S. all rights reserved.<BR>"
			+ "<A HREF='http://www.sds-corp.co.jp/'>http://www.sds-corp.co.jp/</A><BR>"
			+ "<HR BGCOLOR='gray'>"
			+ "totalMemory=" + rt.totalMemory() + "<BR>"
			+ "freeMemory=" + rt.freeMemory() + "<BR>"
			+ "</HTML>";
		JEditorPane lbl = new JEditorPane( "text/html", html );
		lbl.setEditable( false );
		lbl.addHyperlinkListener( new HyperlinkListener() {
			public void hyperlinkUpdate(HyperlinkEvent e) {
				if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
					JEditorPane pane = (JEditorPane) e.getSource();
					if (e instanceof HTMLFrameHyperlinkEvent) {
						HTMLFrameHyperlinkEvent  evt = (HTMLFrameHyperlinkEvent)e;
						HTMLDocument doc = (HTMLDocument)pane.getDocument();
						doc.processHTMLFrameHyperlinkEvent(evt);
					} else {
						try {
							pane.setPage(e.getURL());
						} catch (Exception t) {
							t.printStackTrace();
						}
					}
				}
			}
		} );
		String text;
		text = res.getString( "about.title" );
		JOptionPane.showMessageDialog( this,
			lbl, text,
			JOptionPane.INFORMATION_MESSAGE );
	}

}
