package jp.co.sds_corp.syslog.viewer;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.text.SimpleDateFormat;
import java.util.ResourceBundle;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import jp.co.sds_corp.util.syslog.SyslogMsg;
import jp.co.sds_corp.util.window.WindowUtility;
import jp.co.sds_corp.util.window.XYConstraints;
import jp.co.sds_corp.util.window.XYLayout;

/**
* syslogの詳細表示ダイアログです。
*/
public class DescDialog extends JDialog
{
	private static final long serialVersionUID = 1L;
	SyslogParam	param;

	XYLayout xyLayout = new XYLayout( 477, 421 );
	JTextArea TXT_MSG = new JTextArea( "" ) {
		private static final long serialVersionUID = 1L;
/*
		public boolean isFocusable() {
			return false;
		}
*/
	};
	JScrollPane	TXT_MSG_sp = new JScrollPane( TXT_MSG );
	JButton BTN_OK = new JButton( "OK" );
	JButton BTN_PREV;
	JButton BTN_NEXT;

	JLabel LBL_DATE = new JLabel( "yyyy/mm/dd" );
	JLabel LBL_TIME = new JLabel( "hh:mm:ss.SSS" );
	JLabel LBL_FACILITY = new JLabel( "XXXXX" );
	JLabel LBL_PRIORITY = new JLabel( "XXXXX" );
	JLabel LBL_HOST = new JLabel( "XXXXX" );
	JLabel LBL_TAG = new JLabel( "XXXXX" );
	JLabel LBL_IDENT = new JLabel( "XXXXX" );
	JLabel LBL_ORGTIME = new JLabel( "XXXXX" );
	JLabel LBL_ICON = new JLabel();
	ResourceBundle res;

	public DescDialog( JDialog parent, SyslogParam param ) {
		super( parent );
		this.param = param;
		createControls();
	}

	public DescDialog( JFrame parent, SyslogParam param ) {
		super( parent );
		this.param = param;
		createControls();
	}

	public DescDialog( SyslogParam param ) {
		super();
		this.param = param;
		createControls();
	}

	protected void createControls() {
		WindowUtility.setHideOnEscape( this );
		res = ResourceBundle.getBundle( "resource.viewer" );
		String text;
		text = res.getString( "desc.title" );
		setTitle( text );
		setSize( 477, 421 );
		getContentPane().setLayout( xyLayout );
		setFont( param.getDefaultFont() );
		setResizable( false );

		WindowUtility.setHideOnEscape( this );

		JLabel lbl;
		text = res.getString( "desc.date" );
		lbl = new JLabel( text );
		getContentPane().add( lbl, new XYConstraints( 68,6,42,13) );
		text = res.getString( "desc.time" );
		lbl = new JLabel( text );
		getContentPane().add( lbl, new XYConstraints( 68,24,44,13) );
		text = res.getString( "desc.facility" );
		lbl = new JLabel( text );
		getContentPane().add( lbl, new XYConstraints( 68,60,72,13) );
		text = res.getString( "desc.priority" );
		lbl = new JLabel( text );
		getContentPane().add( lbl, new XYConstraints( 68,78,66,13) );
		text = res.getString( "desc.host" );
		lbl = new JLabel( text );
		getContentPane().add( lbl, new XYConstraints( 68,42,54,13) );
		text = res.getString( "desc.tag" );
		lbl = new JLabel( text );
		getContentPane().add( lbl, new XYConstraints( 248,42,66,13) );
		text = res.getString( "desc.ident" );
		lbl = new JLabel( text );
		getContentPane().add( lbl, new XYConstraints( 248,60,66,13) );
		text = res.getString( "desc.orgtime" );
		lbl = new JLabel( text );
		getContentPane().add( lbl, new XYConstraints( 248,78,66,13) );

		text = res.getString( "desc.prev.text" );
		BTN_PREV = new JButton( text );
		text = res.getString( "desc.next.text" );
		BTN_NEXT = new JButton( text );
		getContentPane().add( TXT_MSG_sp, new XYConstraints( 19,102,434,240) );
		getContentPane().add( BTN_OK, new XYConstraints( 200,360,70,26) );
		getContentPane().add( BTN_PREV, new XYConstraints( 110,360,70,26) );
		getContentPane().add( BTN_NEXT, new XYConstraints( 290,360,70,26) );
		getContentPane().add( LBL_DATE, new XYConstraints( 146,6,85,13) );
		getContentPane().add( LBL_TIME, new XYConstraints( 146,24,95,13) );
		getContentPane().add( LBL_FACILITY, new XYConstraints( 146,60,95,13) );
		getContentPane().add( LBL_PRIORITY, new XYConstraints( 146,78,95,13) );
		getContentPane().add( LBL_HOST, new XYConstraints( 146,42,95,13) );
		getContentPane().add( LBL_TAG, new XYConstraints( 306,42,162,13) );
		getContentPane().add( LBL_IDENT, new XYConstraints( 306,60,162,13) );
		getContentPane().add( LBL_ORGTIME, new XYConstraints( 306,78,162,13) );
		getContentPane().add( LBL_ICON, new XYConstraints( 8, 24, 50, 50 ) );

		TXT_MSG.setEditable( false );
		TXT_MSG.setWrapStyleWord( true );
		TXT_MSG.setLineWrap( true );
		TXT_MSG_sp.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);

		BTN_OK.requestFocus();
		getRootPane().setDefaultButton( BTN_OK );
		BTN_OK.addActionListener( new ActionListener() {
			public void actionPerformed( ActionEvent e ) {
				onCancel();
			}
		});
	}

	SimpleDateFormat sdf1 = new SimpleDateFormat( "yyyy/MM/dd" );
	SimpleDateFormat sdf2 = new SimpleDateFormat( "HH:mm:ss.SSS" );

	public void setData( SyslogMsg msg, int nAll, int nPos ) {
		LBL_DATE.setText( sdf1.format( msg.getDate().getTime() ));
		LBL_TIME.setText( sdf2.format( msg.getDate().getTime() ));
		if ( param.getHostAsName()) {
			LBL_HOST.setText( msg.getAddress().getHostName());
		} else {
			LBL_HOST.setText( msg.getAddress().getHostAddress());
		}
		LBL_PRIORITY.setText( msg.getPriority().toString() );
		LBL_FACILITY.setText( msg.getFacility().toString() );
		LBL_ORGTIME.setText( msg.getOrgTime());
		LBL_TAG.setText( msg.getTag());
		LBL_IDENT.setText( msg.getIdent());
		TXT_MSG.setText( msg.getMessage());
		LBL_ICON.setIcon( param.getIcon( msg, 50 ) );

		if ( nPos <= 0 ) {
			BTN_PREV.setEnabled( false );
		} else {
			BTN_PREV.setEnabled( true );
		}
		if ( nAll <= nPos + 1 ) {
			BTN_NEXT.setEnabled( false );
		} else {
			BTN_NEXT.setEnabled( true );
		}
	}

	public void onCancel() {
		setVisible( false );
	}

}
