package jp.co.sds_corp.syslog.viewer.statistics;

import java.awt.Color;

import jp.co.sds_corp.util.syslog.Facility;
import jp.co.sds_corp.util.syslog.Priority;

/**
Facility,Priorityごとの色の設定を保持します。
*/
public class ColorDefine
{
	Priority[] arrpri = {
		Priority.EMERG, 
		Priority.ALERT, 
		Priority.CRIT, 
		Priority.ERR, 
		Priority.WARNING, 
		Priority.NOTICE, 
		Priority.INFO, 
		Priority.DEBUG
	};
	Color[] pcol = {
		Color.magenta,
		Color.pink,
		Color.orange,
		Color.red,
		Color.yellow,
		Color.green,
		Color.blue,
		Color.black
	};

	Facility[] arrfac = {
		Facility.KERN, 
		Facility.USER, 
		Facility.MAIL, 
		Facility.DAEMON, 
		Facility.AUTH,
		Facility.SYSLOG,
		Facility.LPR,
		Facility.NEWS,
		Facility.UUCP,
		Facility.CRON,
		Facility.AUTHPRIV,
		Facility.FTP,
		Facility.LOCAL0,
		Facility.LOCAL1,
		Facility.LOCAL2,
		Facility.LOCAL3,
		Facility.LOCAL4,
		Facility.LOCAL5,
		Facility.LOCAL6,
		Facility.LOCAL7
	};
	Color[] fcol = {
		Color.red,
		Color.blue,
		Color.black,
		Color.yellow,
		Color.magenta,
		Color.pink,
		Color.black,
		Color.black,
		Color.black,
		Color.black,
		Color.orange,
		Color.black,
		Color.cyan,
		Color.black,
		Color.black,
		Color.black,
		Color.black,
		Color.black,
		Color.black,
		Color.black
	};

	public Color getColor( Object obj ) {
		Color	ret;
		if ( obj instanceof Priority ) {
			ret = getPriorityColor( (Priority )obj );
		} else
		if ( obj instanceof Facility ) {
			ret = getFacilityColor( (Facility )obj );
		} else {
			ret = Color.gray;
		}
		return ret;
	}

	private int findPriority( Priority pri ) {
		int i;
		for ( i = 0; i < arrpri.length; i++ ) {
			if ( arrpri[i].equals( pri )) {
				return i;
			}
		}
		return -1;
	}

	public Color getPriorityColor( Priority pri ) {
		int pos = findPriority( pri );
		if ( pos < 0 ) {
			return Color.white;
		}
		return pcol[pos];
	}

	public void setPriorityColor( Priority pri, Color col ) {
		int pos = findPriority( pri );
		if ( pos < 0 ) {
			return;
		}
		pcol[pos] = col;
	}

	private int findFacility( Facility fac ) {
		int i;
		for ( i = 0; i < arrfac.length; i++ ) {
			if ( arrfac[i].equals( fac )) {
				return i;
			}
		}
		return -1;
	}

	public Color getFacilityColor( Facility fac ) {
		int pos = findFacility( fac );
		if ( pos < 0 ) {
			return Color.white;
		}
		return fcol[pos];
	}

	public void setFacilityColor( Facility fac, Color col ) {
		int pos = findFacility( fac );
		if ( pos < 0 ) {
			return;
		}
		fcol[pos] = col;
	}

}

